/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     |
    \\  /    A nd           | Copyright (C) 1991-2008 OpenCFD Ltd.
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the
    Free Software Foundation; either version 2 of the License, or (at your
    option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM; if not, write to the Free Software Foundation,
    Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

\*---------------------------------------------------------------------------*/

// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

inline const Foam::fvMesh& Foam::colloidParticleCloud::mesh() const
{
    return mesh_;
}


inline Foam::scalar Foam::colloidParticleCloud::rhop() const
{
    return rhop_;
}


inline Foam::scalar Foam::colloidParticleCloud::e() const
{
    return e_;
}


inline Foam::scalar Foam::colloidParticleCloud::mu() const
{
    return mu_;
}

inline Foam::scalar Foam::colloidParticleCloud::rhoc() const
{
    return rhoc_;
}

inline Foam::scalar Foam::colloidParticleCloud::nuc() const
{
    return nuc_;
}

inline Foam::word Foam::colloidParticleCloud::vdwModel() const
{
    return vdwModel_;
}

inline Foam::word Foam::colloidParticleCloud::edlModel() const
{
    return edlModel_;
}

inline Foam::scalar Foam::colloidParticleCloud::Awall() const
{
    return Awall_;
}

inline Foam::scalar Foam::colloidParticleCloud::Apart() const
{
    return Apart_;
}

inline Foam::scalar Foam::colloidParticleCloud::psiWall() const
{
    return psiWall_;
}

inline Foam::scalar Foam::colloidParticleCloud::psiPart() const
{
    return psiPart_;
}

inline Foam::scalar Foam::colloidParticleCloud::molarity() const
{
    return molarity_;
}

inline Foam::scalar Foam::colloidParticleCloud::perm() const
{
    return perm_;
}

inline Foam::scalar Foam::colloidParticleCloud::T() const
{
    return T_;
}

inline Foam::tmp<Foam::volVectorField> Foam::colloidParticleCloud::momentumSource(const dimensionedScalar& rho) const
{
    tmp<Foam::volVectorField> tsource
    (
        new Foam::volVectorField
        (
            IOobject
            (
                "sms",
                runTime_.timeName(),
                mesh_,
                IOobject::NO_READ,
                IOobject::NO_WRITE
            ),
            mesh_,
            dimensionedVector
            (
                "zero",
                dimensionSet(0, 1, -2, 0, 0),
                vector::zero
            )
        )
    );

    if(useSourceMoment_) {
    tsource().internalField() = smoment_/mesh_.time().deltaT().value()/mesh_.V()/rho.value();
    }

    return tsource;
}

inline const Foam::collisionModel& Foam::colloidParticleCloud::collisions() const
{
    return collisionModel_;
}
// ************************************************************************* //
