/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     |
    \\  /    A nd           | Copyright (C) 1991-2008 OpenCFD Ltd.
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the
    Free Software Foundation; either version 2 of the License, or (at your
    option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM; if not, write to the Free Software Foundation,
    Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

\*---------------------------------------------------------------------------*/

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

inline Foam::colloidParticle::trackData::trackData
(
    colloidParticleCloud& spc,
    //const interpolationCellPoint<scalar>& rhoInterp,
    const interpolationCellPoint<vector>& UInterp,
    //const interpolationCellPoint<scalar>& nuInterp,
    const vector& g
)
:
    spc_(spc),
    //rhoInterp_(rhoInterp),
    UInterp_(UInterp),
    //nuInterp_(nuInterp),
    g_(g)
{}


inline Foam::colloidParticle::colloidParticle
(
    const Cloud<colloidParticle>& c,
    const vector& position,
    const label celli,
    const scalar d,
    const vector& U
)
:
    Particle<colloidParticle>(c, position, celli),
    d_(d),
    U_(U)
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

inline Foam::colloidParticleCloud& Foam::colloidParticle::trackData::spc()
{
    return spc_;
}

/*inline const Foam::interpolationCellPoint<Foam::scalar>&
Foam::colloidParticle::trackData::rhoInterp() const
{
    return rhoInterp_;
}*/

inline const Foam::interpolationCellPoint<Foam::vector>&
Foam::colloidParticle::trackData::UInterp() const
{
    return UInterp_;
}

/*inline const Foam::interpolationCellPoint<Foam::scalar>&
Foam::colloidParticle::trackData::nuInterp() const
{
    return nuInterp_;
}*/

inline const Foam::vector& Foam::colloidParticle::trackData::g() const
{
    return g_;
}


inline Foam::scalar Foam::colloidParticle::d() const
{
    return d_;
}

inline Foam::scalar Foam::colloidParticle::wallImpactDistance(const vector&) const
{
    return 0.5*d_;
}

inline const Foam::vector& Foam::colloidParticle::U() const
{
    return U_;
}

inline Foam::scalar Foam::colloidParticle::m() const
{
    return m_;
}


// ************************************************************************* //
